// ReproClient.cpp : Definiert den Einstiegspunkt fr die Konsolenanwendung.
//

#include "stdafx.h"

#include <iostream>
#include <boost/array.hpp>
#include <boost/asio.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>

using boost::asio::ip::tcp;
using namespace boost::posix_time; 

//int _tmain(int argc, _TCHAR* argv[])
int main(int argc, char* argv[]) 
{
   try
   {
     if (argc != 2)
     {
       std::cerr << "Usage: client <host>" << std::endl;
       return 1;
     }

     boost::asio::io_service io_service;
     boost::asio::ip::tcp::endpoint endpoint(boost::asio::ip::address::from_string( argv[1] ), 8002 );

     tcp::socket socket(io_service);
     boost::system::error_code error = boost::asio::error::host_not_found;
     socket.connect( endpoint, error );
     if (error)
       throw boost::system::system_error(error);

     int counter = 0;
     unsigned char* array = new unsigned char[307400];
     for (;;)
     {
       boost::system::error_code error;

       ptime startTime = microsec_clock::universal_time();
       size_t len = boost::asio::read( socket,
                                      boost::asio::buffer( array, 307400 ),
                                      boost::asio::transfer_all(),
                                      error );
       time_duration neededTime = microsec_clock::universal_time() - startTime;

       if ( error ) {
         printf( "body read error %s\n", error.message().c_str() );
       }

       if ( counter % 5000 == 0 ) {
         std::cout << "passed: " << counter << "\r";
       }
       ++counter;

       if ( neededTime.total_milliseconds() > 1000 ) {
         std::cout << "ERROR needed too much time: " << neededTime.total_milliseconds() << "ms" << std::endl;
       }
     }
   }
   catch (std::exception& e)
   {
     std::cerr << e.what() << std::endl;
   }

   return 0; 
}

